Codeforces Round #388 (Div. 2) D

There are n people taking part in auction today. The rules of auction are classical. There were n bids made, though it‘s not guaranteed they were from different people. It might happen that some people made no bids at all.

Each bid is define by two integers (ai,?bi), where ai is the index of the person, who made this bid and bi is its size. Bids are given in chronological order, meaning bi?<?bi?+?1 for all i?<?n. Moreover, participant never makes two bids in a row (no one updates his own bid), i.e.ai?≠?ai?+?1 for all i?<?n.

Now you are curious with the following question: who (and which bid) will win the auction if some participants were absent? Consider that if someone was absent, all his bids are just removed and no new bids are added.

Note, that if during this imaginary exclusion of some participants it happens that some of the remaining participants makes a bid twice (or more times) in a row, only first of these bids is counted. For better understanding take a look at the samples.

You have several questions in your mind, compute the answer for each of them.

Input

The first line of the input contains an integer n (1?≤?n?≤?200?000) — the number of participants and bids.

Each of the following n lines contains two integers ai and bi (1?≤?ai?≤?n,?1?≤?bi?≤?109,?bi?<?bi?+?1) — the number of participant who made the i-th bid and the size of this bid.

Next line contains an integer q (1?≤?q?≤?200?000) — the number of question you have in mind.

Each of next q lines contains an integer k (1?≤?k?≤?n), followed by k integers lj (1?≤?lj?≤?n) — the number of people who are not coming in this question and their indices. It is guarenteed that lj values are different for a single question.

It‘s guaranteed that the sum of k over all question won‘t exceed 200?000.

Output

For each question print two integer — the index of the winner and the size of the winning bid. If there is no winner (there are no remaining bids at all), print two zeroes.

Examples

input

61 102 1003 10001 100002 1000003 100000031 32 2 32 1 2

output

2 1000001 103 1000

input

31 102 1001 100022 1 22 2 3

output

0 01 10

Note

Consider the first sample:

  • In the first question participant number 3 is absent so the sequence of bids looks as follows:

    1. 1 10
    2. 2 100
    3. 1 10?000
    4. 2 100?000

    Participant number 2 wins with the bid 100?000.

  • In the second question participants 2 and 3 are absent, so the sequence of bids looks:
    1. 1 10
    2. 1 10?000

    The winner is, of course, participant number 1 but the winning bid is 10 instead of 10?000 as no one will ever increase his own bid (in this problem).

  • In the third question participants 1 and 2 are absent and the sequence is:
    1. 3 1?000
    2. 3 1?000?000

    The winner is participant 3 with the bid 1?000.

题意:有个拍卖会,然后出价(出价貌似是上升的),最后说有几个出价是失效的,问最后是哪个价格竞拍到了

1 102 1003 10001 100002 1000003 1000000比如这个,我们知道每人两次出价(价格上升),最后3出价失效,最后保留1 2,2的出价最高,输出2 10000

解法:

1 模拟

2 没有剩下就是的0 0,剩下一个出价人就是取最高值

3 如果留下多个,最后一个出价人的价格和倒数第二个出价比较,找一个比倒数第二个出价最高的还高的出价就行(不一定要最高),如果找不到就取当前的最大值

4 说是数据结构,拿现成的工具套。。

 1 #include<bits/stdc++.h>
 2 typedef long long LL;
 3 typedef unsigned long long ULL;
 4 typedef long double LD;
 5 using namespace std;
 6 set<pair<int,int>>Se;
 7 vector<int>Ve[400000];
 8 int flag[400000];
 9 int query[200000];
10 int main(){
11     int n;
12     scanf("%d",&n);
13     for(int i=1;i<=n;i++){
14         int a,b;
15         scanf("%d%d",&a,&b);
16         Ve[a].push_back(b);
17         flag[a]=1;
18     }
19     for(int i=0;i<=n;i++){
20         if(flag[i]){
21             Se.insert({Ve[i][Ve[i].size()-1],i});
22         }
23     }
24     int m;
25     scanf("%d",&m);
26     while(m--){
27         int num;
28         scanf("%d",&num);
29         for(int i=1;i<=num;i++){
30             scanf("%d",&query[i]);
31             if(flag[query[i]]==0) continue;
32             Se.erase({Ve[query[i]][Ve[query[i]].size()-1],query[i]});
33         }
34         if(Se.size()==0){
35             printf("0 0\n");
36         }else if(Se.size()==1){
37             printf("%d %d\n",Se.begin()->second,Ve[Se.begin()->second][0]);
38         }else{
39             auto k = --Se.end();
40             int t1 = k->first, t2 = k->second;
41             Se.erase({t1, t2});
42             auto l = --Se.end();
43             printf("%d %d\n", k->second, *upper_bound(Ve[t2].begin(), Ve[t2].end(), l->first));
44             Se.insert({t1, t2});
45         }
46         for(int i=1;i<=num;i++){
47             if(flag[query[i]]){
48                 Se.insert({Ve[query[i]][Ve[query[i]].size()-1],query[i]});
49             }
50         }
51     }
52     return 0;
53 }
时间: 2024-11-08 17:29:39

Codeforces Round #388 (Div. 2) D的相关文章

Codeforces Round #388 (Div. 2) C. Voting

题意:有n个人,每个人要么是属于D派要么就是R派的.从编号1开始按顺序,每个人都有一次机会可以剔除其他任何一个人(被剔除的人就不在序列中也就失去了剔除其他人的机会了):当轮完一遍后就再次从头从仅存的人中从编号最小开始重复执行上述操作,直至仅存在一派,问最后获胜的是哪一派? 并且,题目假设每个人的选择是最优的,即每个人的操作都是会尽可能的让自己所属的派获胜的. 题解: 一开始看到说每个人的操作都会是最优的还以为是个博弈(=_=),,,仔细琢磨了下样例发现并不用,只要贪心模拟就行了.贪心的策略并不难

Codeforces Round #388 (Div. 2) C

There are n employees in Alternative Cake Manufacturing (ACM). They are now voting on some very important question and the leading world media are trying to predict the outcome of the vote. Each of the employees belongs to one of two fractions: depub

Codeforces Round #388 (Div. 2) 749E(巧妙的概率dp思想)

题目大意 给定一个1到n的排列,然后随机选取一个区间,让这个区间内的数随机改变顺序,问这样的一次操作后,该排列的逆序数的期望是多少 首先,一个随机的长度为len的排列的逆序数是(len)*(len-1)/4,这是显然的,因为每种排列倒序一遍就会得到一个新序列,逆序数是len*(len-1)/2 - x(x为原排列的逆序数) 所以我们只需要把所有n*(n-1)/2的区间每种情况都随机化一遍再求逆序对,然后把这个值求和,就可以得到答案了 但是如果用朴素做法,那么复杂度是n^2的 考虑dp[x]表示以

Codeforces Round #388 (Div. 2) B

Long time ago Alex created an interesting problem about parallelogram. The input data for this problem contained four integer points on the Cartesian plane, that defined the set of vertices of some non-degenerate (positive area) parallelogram. Points

Codeforces Round #388 (Div. 2) A

Bachgold problem is very easy to formulate. Given a positive integer n represent it as a sum of maximum possible number of prime numbers. One can prove that such representation exists for any integer greater than 1. Recall that integer k is called pr

Codeforces Round #279 (Div. 2) ABCD

Codeforces Round #279 (Div. 2) 做得我都变绿了! Problems # Name     A Team Olympiad standard input/output 1 s, 256 MB  x2377 B Queue standard input/output 2 s, 256 MB  x1250 C Hacking Cypher standard input/output 1 s, 256 MB  x740 D Chocolate standard input/

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我